/*
Title:			tickerpumpkin.c
Author:			Windell Oskay  http://www.evilmadscientist.com/
Date Created:   10/2008
Copyright 2008 Windell H. Oskay
Distributed under the terms of the GNU General Public License, please see below.


Purpose: Drive stock-ticker

Makefile commands:  make all, make install.  Be sure to change the "programmer" name at the top of the makefile if necessary.

This code should be relatively straigtforward, so not much documentation is provided.  If you'd like to ask 
questions, suggest improvements, or report success, please use the evilmadscientist forum:
http://www.evilmadscientist.com/forum/
 

Fusing notes:
We will want to run with the 8 MHz internal RC oscillator,
and with the clock prescaler turned off (divide by 1)


 This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


*/



#include <avr/io.h>  
 
#include <math.h>
#include <avr/pgmspace.h> 

#define delaytime 100U


// Global vars:	
unsigned char columns[14];	


void delay()
{
unsigned int delayvar;
	delayvar = 0; 
	while (delayvar <=  delaytime)		
		{ 
			asm("nop");  
			delayvar++;
		}
}

  
/******** BEGIN FONT AND STRING DEFINITIONS ********/

const unsigned char font_table[40][5] PROGMEM = 
{
	{15,20,20,15,0},	//A
	{31,21,21,10,0},	//B
	{14,17,17,10,0},	//C
	{31,17,17,14,0},	//D
	{31,21,21,17,0},	//E

	{31,20,20,16,0},	//F
	{14,17,21,22,0}, 	//G
	{31,4,4,31,0},  	//H
	{17,31,17,0,0}, 	//I
	{2,1,1,30,0},   	//J
	
	{31,4,10,17,0}, 	//K
	{31,1,1,0,0},   	//L
	{31,8,4,8,31},  	//M
	{31,8,4,2,31},  	//N
	{14,17,17,14,0},    //O

	{31,20,20,8,0}, 	//P
	{14,17,17,18,13},	//Q
	{31,20,22,9,0}, 	//R
	{9,21,21,21,18}, 	//S
	{16,16,31,16,16},	//T

	{30,1,1,30,0},  	//U
	{28,2,1,2,28},  	//V
	{31,2,4,2,31},  	//W
	{17,10,4,10,17},		//X
	{16,8,7,8,16},  	//Y
	
	{17,19,21,25,17},	//Z
	{14,17,17,14,0},	//0
	{17,31,1,0,0},  	//1
	{9,19,21,21,9},  	//2
	{17,21,21,10,0},	//3

	{28,4,31,4,0},  	//4
	{29,21,21,18,0},	//5
	{14,21,21,2,0}, 	//6
	{16,19,20,24,0}, 	//7
	{10,21,21,10,0},	//8

	{8,21,21,14,0}, 	//9
	{4,8,31,8,4},		// +  (Up arrow used)
	{4,2,31,2,4},		// -  (down arrow used)
	{0,0,0,0,0},			//space
	{1,0,0,0,0}			//decimal
		
	//{4,8,31,8,4},   	//up arrow
	//{4,2,31,2,4},    	//down arrow
	
	}; 

const unsigned char width_table[40] PROGMEM = 
{
	4,	//A
	4,	//B
	4,	//C
	4,	//D
	4,	//E

	4,	//F
	4,	//G
	4,	//H
	3,	//I
	4,	//J

	4,	//K
	3,	//L
	5,	//M
	5,	//N
	4,	//O
	
	4,	//P
	5,	//Q
	4,	//R
	5,	//S
	5,	//T

	4,	//U
	5,	//V
	5,	//W
	5,	//X
	5,	//Y
	
	5,	//Z
	4,	//0
	3,	//1
	5,	//2
	4,	//3

	4,	//4
	4,	//5
	4,	//6
	4,	//7
	4,	//8						 	

	4,	//9
	5,	// +
	5,	// -
	3,	//space
	1	//decimal
	
//	5,	//up arrow
//	5,	//down arrow
	
	}; 
	
	
	
	
	
	
void refresh(void){
  


PORTD = columns[6];
PORTC = columns[13];
PORTB = 128;
delay();
PORTB = 0;
 
PORTD = columns[5];
PORTC = columns[12];
PORTB = 64;
delay();
PORTB = 0;
  
PORTD = columns[4];
PORTC = columns[11];
PORTB = 2;
delay();
PORTB = 0; 

PORTD = columns[3];
PORTC = columns[10];
PORTB = 1;
delay();  
PORTB = 0;  
  
PORTD = columns[2];
PORTC = columns[9];
PORTD |= 128;
delay();
//PORTD = 0;

PORTD = columns[1];
PORTC = columns[8];
PORTD |= 64;
delay();
//PORTD = 0;

PORTD = columns[0];
PORTC = columns[7];
PORTD |= 32;
delay();
PORTD = 0;




}




void LoadNewColumn(unsigned char inputChar)
{
   

columns[0]  = columns[1]; 
columns[1]  = columns[2]; 
columns[2]  = columns[3]; 
columns[3]  = columns[4]; 
columns[4]  = columns[5]; 
columns[5]  = columns[6]; 
columns[6]  = columns[7]; 
columns[7]  = columns[8]; 
columns[8]  = columns[9]; 
columns[9]  = columns[10]; 
columns[10] = columns[11]; 
columns[11] = columns[12]; 
columns[12] = columns[13]; 
columns[13] = inputChar;
return;
}




	
//Because the font tables are in program memory, we can actually have a fairly long 
// string here.  (Longer-yet strings can also be stored in program memory if necessary.)

//Strings for font tests:	
//const char String[] = "A B C D E F G H I J K L M N O P Q R S T U V W X Y Z ;";
//const char String[] = "12345678901234567890.;";

// Todays values:  Actually aren't all that scary, for better or worse.
const char String[] = "DJI 9065.12 +889.35  INX 940.51 +91.59   \
AAPL 99.91 +7.82  GOOG 368.75 +39.26  ATML 3.97 +0.45   ;";
	

int main (void)
{    

//unsigned char columns[14];
unsigned int i;		// Dummy variable
unsigned int StringPosition = 0; unsigned char StringChar;	// Character picked out of string
unsigned int FontChar = 0;		// Location in the font_table of our character
unsigned int CharWidth;		// Width of our character in the font table
unsigned int SubCharPos;	// Position advancing the character into the LED matrix
unsigned char SubCharWord;	// Single column of a single character
 

StringPosition = 0;

i = 0;
while (i < 14)
{
	columns[i] = 0;
	i++;
}

 
//Hardware Init:

PORTB = 0;
PORTC = 0;
PORTD = 0;
 
DDRB = 255;  
DDRC = 255;		
DDRD = 255;

for (;;)  // main loop										
{
 
 
if( String[StringPosition] == ';' )	
	StringPosition = 0; // repeat string over and over

StringChar = String[StringPosition];


 
if (StringChar >= 'A')	
	{
		FontChar = StringChar - 'A';
	}

if (StringChar == ' ')
	FontChar = 38;
if (StringChar == '+')	
	FontChar = 36;
if (StringChar == '-')	
	FontChar = 37;			
if (StringChar == '.')	
	FontChar = 39;			
					
if ((StringChar >= '0') && (StringChar <= '9'))	
		FontChar = StringChar - '0' + 26;	
	  
// New character is picked now.  

CharWidth = (uint8_t)pgm_read_word(&width_table[FontChar]);  

 
SubCharPos = 0;

while (SubCharPos <=  CharWidth)
{
 
if (SubCharPos == CharWidth)
	SubCharWord = 0;   // ending gap
else	
	SubCharWord = (uint8_t)pgm_read_word(&font_table[FontChar][SubCharPos]); 
 
 
LoadNewColumn(SubCharWord);
 
 
refresh(); 
refresh(); 
refresh(); 
refresh();  
refresh(); 
refresh(); 
refresh(); 
refresh(); 
refresh(); 
refresh(); 
refresh(); 
refresh(); 
refresh(); 

SubCharPos++;
}
 	
	
	StringPosition++;



  
}	//End main loop.
	return 0;
}
